config/routes.rb
    resources :keys, :only => [:new, :create, :destroy, :index]

    resources :aliases do
      member do
        get :confirm
      end
    end

    get "/repositories" => "repositories#index"
    resource :license, :only => [:show, :edit, :update]
    match "/*slug" => "owner_redirections#show"
  end

  ### R3. Sessions
  resource :sessions
  get "/sessions" => "sessions#create", :as => :open_id_complete
  get "/login" => "sessions#new", :as => :login
  get "/login/http" => "sessions#http" # for Kerberos authentication
  get "/logout" => "sessions#destroy", :as => :logout

  ### R4. Groups
  resources :groups, :only => [:index, :new, :create]
  # `resource :groups` can't do the +<group> ids
  get "/+:id(.:format)" => "groups#show", :as => "group", :id => /[^\/]+/
  get "/+:id/edit(.:format)" => "groups#edit", :as => "edit_group", :id => /[^\/]+/
  put "/+:id(.:format)" => "groups#update", :id => /[^\/]+/
  delete "/+:id(.:format)" => "groups#destroy", :id => /[^\/]+/

  # Additional group actions
  scope "/+:id", :id => /[^\/]+/, :as => :group do
    delete "avatar" => "groups#avatar"
  end

  # Nested group resources. This is in a separate scope because the
  # controllers expect params[:group_id] to contain the group, not
  # params[:id] as in the scope above
  scope "/+:group_id", :id => /[^\/]+/, :as => :group do
    resources :memberships
    get "/repositories" => "repositories#index"
    match "/*slug" => "owner_redirections#show"
  end

  ### R5. Site-wide wiki
  get "/wiki/:site_id/config" => "site_wiki_pages#repository_config", :as => :site_wiki_git_access_connect
  get "/wiki/:site_id/writable_by" => "site_wiki_pages#writable_by", :as => :site_wiki_git_writable_by

  resources :site_wiki_pages, :path => "/wiki" do
    collection do
      get :git_access
    end

    member do
      get :history
    end
  end

  ### R6. Direct merge request access
  match "/merge_request_landing_page" => "merge_requests#oauth_return", :as => :merge_request_landing_page
  get "/merge_requests/:id" => "merge_requests#direct_access", :as => :merge_request_direct_access

  ### R7. Site controller, various loose pages
  get "/activities" => "site#public_timeline", :as => :activity
  get "/dashboard" => "site#dashboard", :as => :dashboard
  get "/my-activities" => "site#my_activities", :as => :dashboard_my_activities
  get "/about" => "site#about", :as => :about
  get "/about/:action" => "site#index", :as => :about_page
  get "/contact" => "site#contact", :as => :contact

  ### R8. Administration
  namespace :admin do
    get "/" => redirect { |params, request| "/admin/repositories" }

    resources :users, :only => [:index, :new, :create] do
      member do
        put :suspend
        put :flip_admin_status
        put :unsuspend
        put :reset_password
      end

      resources :keys, only: [:index, :new, :create, :destroy]
    end

    resources :projects, :only => [:show] do
      resource :oauth_settings, :only => [:show, :edit, :update]
    end

    resources :repositories, :only => [:index] do
      member do
        put :recreate
      end
    end

    resources :project_proposals, :only => [:index, :new, :create]
    post "/project_proposals/:id/reject" => "project_proposals#reject"
    post "/project_proposals/:id/approve" => "project_proposals#approve"
  end

  ### R9. API
  namespace :api do
    get ":project_id/:repository_id/log/graph(.:format)" => "graphs#show"
    get ":project_id/:repository_id/log/graph/*branch(.:format)" => "graphs#show"

    namespace :internal do
      get "/repo-config", to: "repository_configurations#show"
      get "/authenticate", to: "users#authenticate"
      get "/hooks/pre-receive", to: "hooks#pre_receive"
      post "/hooks/post-receive", to: "hooks#post_receive"
    end
  end

  ### R10. Events
  resources :events do
    member do
      get :commits
    end
  end

  ### R11. Additional logged in user resources
  resources :messages do
    collection do
      get :sent
      put :bulk_update
      get :all
      get :auto_complete_for_message_recipients
    end

    member do
      post :reply
      put :read
    end
  end

  resources :favorites, :only => [:index, :create, :update, :destroy]

  ### R12. Search
  get "/search", :controller => "searches", :action => "show", :as => :search

  ### R13. Auto-completion
  resources :user_auto_completions, :only => [:index]
  resources :group_auto_completions, :only => [:index]

  ### R14. Projects
  resources :projects, :only => [:index, :create]
  get "/:id/edit(.:format)" => "projects#edit"

  resources :projects, :path => "/" do
    member do
      put :preview
      get :edit_slug
      put :edit_slug
      get :confirm_delete
      get "/ownership/edit" => "project_ownerships#edit", :as => :transfer_ownership
      put "/ownership/edit" => "project_ownerships#update", :as => :transfer_ownership
    end

    resources :project_memberships, :only => [:index, :new, :create, :destroy]
    get "/community", :controller => :project_community, :action => :index
    get "/merge_requests", :controller => :project_merge_requests, :action => :index

    resources :pages do
      collection do
        get :git_access
      end

      member do
        get :history
      end
    end

    ### R14.2. Repositories

    # Listing repositories and creating new ones happens over
    # /<project>/repositories/, e.g:
    #   /gitorious/repositories/new
    resources :repositories, :only => [:index, :new, :create]

    # Browsing, editing and destroying existing repositories happens over
    # /<project>/<repository_name>/, e.g.:
    #   /gitorious/mainline
    #   /gitorious/mainline/edit
    resources(:repositories, {
                :path => "/",
                :only => [:show, :edit, :update, :destroy]
              }) do
      member do
        post "/create_clone" => "repository_clones#create"
        get "/clone" => "repository_clones#new"
        get "/search_clones" => "repository_clone_searches#show"
        get :committers
        get :confirm_delete
        get "/ownership/edit" => "repository_ownerships#edit", :as => :transfer_ownership
        put "/ownership/edit" => "repository_ownerships#update"
        get "/activities" => "repository_activities#index", :as => :activities
      end

      resources :comments, :controller => :repository_comments, :only => [:index]

      resources :services, :only => [:index, :destroy] do
        collection do
          post "/:service_type" => "services#create", :as => :create
          get "/:service_type" => "services#index"
        end
        resources :service_tests, :as => :tests, :only => [:create]
      end

      match "/community", :controller => :repository_community, :action => :index

      resources :merge_requests do
        collection do
          post :create
          post :commit_list
          post :target_branches
        end

        member do
          get :commit_status
          get :version
          get :terms_accepted
        end

        resources :comments, :controller => :merge_request_comments, :only => [:index, :create, :update]

        get "/diffs(/:version)" => "merge_request_versions#show", :as => :version
        get "/diffs/:version/comments/:commit_range(.:format)" => "merge_request_version_comments#index", :as => :version_comments
        post "/diffs/:version/comments/:commit_range" => "merge_request_version_comments#create", :as => :version_create_comment
        put "/diffs/:version/comments/:id" => "merge_request_version_comments#update", :as => :version_update_comment
        get "/diffs/:version/comments/:id/edit" => "merge_request_version_comments#edit", :as => :version_edit_comment
      end

      resources :repository_memberships, :only => [:new, :create, :destroy]
      resources :committerships, :only => [:index, :create, :edit, :update, :destroy]

      match "/commits/*id/feed(.:format)" => "commits#feed", :as => :formatted_commits_feed
      match "/commits" => "commits#index", :as => :commits
      match "/commits/*branch" => "commits#index", :as => :commits_in_ref, :branch => /.+/

      # Commit comments
      post "/commit/:ref/comments" => "commit_comments#create", :as => :create_commit_comment, :ref => /[^\/]+/
      put "/commit/:ref/comments/:id" => "commit_comments#update", :as => :update_commit_comment, :ref => /[^\/]+/
      get "/commit/:ref/comments.:format" => "commit_comments#index", :as => :commit_comments, :ref => /[^\/]+/

      match "/commit/:from_id/diffs/:id" => "commit_diffs#show", :as => :commit_compare

      match "/commit/:id.:format" => "commits#show", :as => :commit, :format => /diff|patch/
      match "/commit/:id" => "commits#show", :as => :commit, :id => /.*/

      match "/graph" => "graphs#index", :as => :graph
      match "/graph/*branch" => "graphs#index", :as => :graph_in_ref, :branch => /.*/

      match "/trees/" => "trees#index", :as => :trees
      match "/trees/*branch_and_path" => "trees#show", :as => :tree, :format => false

      # These URLs were introduced as a work-around for a Rails bug that
      # prevented URLs like /archive/:branch.:format. Now we can use the
      # "real" URLs, redirect these temps to the proper ones.
      get "/archive-tarball/*branch" => (redirect do |params, request|
        prefix = request.fullpath.split("/archive-tarball").first
        "#{prefix}/archive/#{URI.encode(params[:branch])}.tar.gz"
      end)

      match "/archive/*branch.tar.gz" => "trees#archive", :as => :archive_tar
      match "/archive/*branch.:archive_format" => "trees#archive", :as => :archive

      match "/blobs/raw/*branch_and_path" => "blobs#raw", :as => :raw_blob, :format => false
      match "/blobs/history/*branch_and_path" => "blobs#history", :as => :blob_history, :format => false
      match "/blobs/blame/*branch_and_path" => "blobs#blame", :as => :blame, :format => false
      match "/blobs/*branch_and_path" => "blobs#show", :as => :blob, :format => false
    end
  end

app/controllers/searches_controller.rb
# encoding: utf-8
#--
#   Copyright (C) 2012 Gitorious AS
#   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
#   Copyright (C) 2008 Johan Sørensen <johan@johansorensen.com>
#   Copyright (C) 2008 Tor Arne Vestbø <tavestbo@trolltech.com>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

class SearchesController < ApplicationController
  PER_PAGE = 30
  helper :all
  renders_in_global_context

  def show
    if params[:q].present?
      @all_results = nil  # The unfiltered search result from TS
      @results = filter_paginated(params[:page], PER_PAGE) do |page|
        begin
          @all_results = ThinkingSphinx.search(query,{
                                                :page => page,
                                                :per_page => PER_PAGE,
                                                :classes => [Project, Repository, MergeRequest],
                                                :match_mode => :extended})

          @all_results.to_a
        rescue ThinkingSphinx::QueryError, ThinkingSphinx::SyntaxError
          @all_results = NullSearchResults.new
          @all_results.to_a
        rescue ThinkingSphinx::SphinxError => e
          # silence the exception if the requested page doesn't exist
          raise e unless e.message =~ /offset out of bounds/

          @all_results = NullSearchResults.new
          @all_results.to_a
        end
      end

      unfiltered_results_length = @all_results.nil? ? 0 : @all_results.length
      filtered_results_length = @results.length
      @total_entries = @all_results.total_entries - (unfiltered_results_length - filtered_results_length)
    end

    respond_to do |format|
      format.html do
        render
      end
    end
  end

  private

  def query
    params[:q].to_s.gsub('/', ' ')
  end

  class NullSearchResults
    def total_entries; 0; end
    def length; 0; end
    def to_a; []; end
    def query_time; 0.0; end
  end
end

app/helpers/searches_helper.rb
# encoding: utf-8
#--
#   Copyright (C) 2012 Gitorious AS
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

module SearchesHelper
  def presenter(result)
    case result
    when Project
      ProjectPresenter.new(result)
    when Repository
      RepositoryPresenter.new(result)
    when MergeRequest
      MergeRequestPresenter.new(result)
    end
  end

  class Presenter
    include ERB::Util
    include Rails.application.routes.url_helpers
    include ActionView::Helpers::UrlHelper
    include ActionView::Helpers::TagHelper
  end

  class ProjectPresenter < Presenter

    def initialize(obj)
      @project = obj
    end

    def title
      h(@project.title)
    end

    def url
      @project
    end

    def body
      @project.description
    end

    def tag_list
      @project.tag_list.map do |tag|
        link_to(h(tag), "/search?q=%40category+#{h(tag)}")
      end.to_sentence
    end

    def summary
      "The #{h(title)} project is labeled with #{tag_list}".html_safe
    end
  end

  class RepositoryPresenter < Presenter
    def initialize(obj)
      @repository = obj
    end

    def title
      [h(@repository.project.slug), h(@repository.name)].join("/")
    end

    def url
      [@repository.project, @repository]
    end

    def body
      @repository.description
    end

    def summary
      "The #{title} repository in #{h(@repository.project.slug)}"
    end
  end

  class MergeRequestPresenter < Presenter
    def initialize(obj)
      @merge_request = obj
    end

    def title
      h(@merge_request.summary) || "merge request ##{@merge_request.sequence_number}"
    end

    def url
      [@merge_request.target_repository.project, @merge_request.target_repository, @merge_request]
    end

    def body
      @merge_request.proposal
    end

    def summary
      "An #{@merge_request.status_tag} merge request to #{@merge_request.target_repository.project.slug}/#{@merge_request.target_repository.name}"
    end
  end
end

app/views/searches/_result.html.erb
<%
#--
#   Copyright (C) 2012 Gitorious AS
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++
%>

<dt>
  <%= link_to(truncate(h(result.title), :length => 40), result.url) %>
</dt>
<dd>
  <div class="muted">
    <%= truncate(h(result.body), :length => 250) %>
  </div>
  <div class="hint">
    <%= result.summary %>
  </div>
</dd>

app/views/searches/_search_box.html.erb
<%
  #--
  #   Copyright (C) 2012 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #   Copyright (C) 2009 Fabio Akita <fabio.akita@gmail.com>
  #   Copyright (C) 2008 Johan Sørensen <johan@johansorensen.com>
  #   Copyright (C) 2008 Tor Arne Vestbø <tavestbo@trolltech.com>
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>

<% hide_tips ||= false -%>

<div class="search_bar_results">
  <%= form_for :search, :url => search_path, :html => { :method => "get", :class => 'form-search' } do |f| -%>
  <p>
    <%= text_field_tag :q, params[:q], :class => "input-xxlarge search-query" -%>
    <input type="submit" value="<%= t("views.searches.search") %>" class="btn" />
  </p>
  <p class="hint search-hint" style="display: none;">
    <%= t("views.searches.hint") %>
    <% unless hide_tips -%>
      - <small><a id="advanced-search-toggler" href="#advanced">Advanced search tips</a></small>
    <% end -%>
  </p>
<% end -%>
</div>

app/views/searches/_search_box_global.html.erb
<%
  #--
  #   Copyright (C) 2012 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #   Copyright (C) 2009 Fabio Akita <fabio.akita@gmail.com>
  #   Copyright (C) 2008 Johan Sørensen <johan@johansorensen.com>
  #   Copyright (C) 2008 Tor Arne Vestbø <tavestbo@trolltech.com>
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>

<% hide_tips ||= false -%>

<div class="search_bar">
  <%= form_for :search, :url => search_path, :html => { :method => "get" } do |f| -%>
  <p>
    <%= text_field_tag :q, params[:q], :class => "text search-field round-5" -%>
    <input type="submit" value="<%= t("views.searches.search") %>" class="search-submit round-5" />
  </p>
  <p class="hint search-hint" style="display: none;">
    <%= t("views.searches.hint") %>
    <% unless hide_tips -%>
      - <small><a id="advanced-search-toggler" href="#advanced">Advanced search tips</a></small>
    <% end -%>
  </p>
<% end -%>
</div>

app/views/searches/show.html.erb
<%
  # encoding: utf-8
  #--
  #   Copyright (C) 2012 Gitorious AS
  #   Copyright (C) 2009 Fabio Akita <fabio.akita@gmail.com>
  #   Copyright (C) 2008 Johan Sørensen <johan@johansorensen.com>
  #   Copyright (C) 2008 Tor Arne Vestbø <tavestbo@trolltech.com>
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>

<% @page_title = @search.blank? ? t("views.searches.search") : t("views.searches.page_title", :term => h(params[:q])) -%>

<div class="gts-site-header">
  <div class="container">
    <h1><%= @page_title -%></h1>
    <% if @results -%>
      <p class="hint search_time">
        <small><%= t("views.searches.found", :count => @total_entries, :time => @all_results.query_time) %></small>
      </p>
    <% end -%>
    <%= render "search_box", :hide_tips => false %>
  </div>
</div>

<div class="container">
  <div class="row-fluid">
    <div class="span7">
      <% if @results.blank? -%>
        <p class="well no-results-box">
          <%= t("views.searches.no_results", :term => h(params[:q].to_s.force_utf8)) %>
        </p>
      <% else -%>
        <dl class="search-results">
          <% @results.each do |result| -%>
            <%= render "result", :result => presenter(result) %>
          <% end -%>
        </dl>
        <div class="will-paginate-pager">
          <%= render_pagination_links (@results) -%>
        </div>
      <% end -%>
    </div>
    <% if @results.blank? %>
      <div class="span5">
        <div class="well search-tips">
          <h2>Tips for searching</h2>
          <p>
            Any combination of the following keys can be used to narrow down
            the search results, simply type <code>key:text</code> into the search field
            to search for <em>text</em> within the scope of the <em>key</em> described below:
          </p>
          <dl>
            <dt>Projects</dt>
            <dd>
              <ul class="unstyled">
                <li><code>@title</code> Project title</li>
                <li><code>@description</code> Project description</li>
                <li><code>@slug</code> Project slug</li>
                <li><code>@category</code> Project label</li>
                <li><code>@user</code> Project creator username</li>
              </ul>
            </dd>
            <dt>Repositories</dt>
            <dd>
              <ul class="unstyled">
                <li><code>@name</code> Repository name</li>
                <li><code>@description</code> Repository description</li>
              </ul>
            </dd>
            <dt>Merge Requests</dt>
            <dd>
              <ul class="unstyled">
                <li><code>@proposal</code> Merge request proposal body</li>
                <li><code>@proposed_by</code> Merge request creator username</li>
                <li><code>@status </code> Merge request status</li>
              </ul>
            </dd>
          </dl>
        </div>
      </div>
    <% end %>
  </div>
</div>